orte/mca/rds/rds.h File Reference.TH "orte/mca/rds/rds.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/rds/rds.h \- The Open RTE Resource Discovery Subsystem (RDS). 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include 'include/orte_constants.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/ns/ns_types.h'\fP
.br
\fC#include 'mca/rds/rds_types.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBORTE_RDS_BASE_VERSION_1_0_0\fP"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef int(* \fBorte_rds_base_module_query_fn_t\fP )(void)"
.br
.RI "\fIQuery/update a resource The query function requests that the component read its associated information and store/update it on the ORTE_RESOURCE_SEGMENT of the registry. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rds_base_module_finalize_fn_t\fP )(void)"
.br
.RI "\fICleanup module resources. \fP"
.ti -1c
.RI "typedef int(* \fBorte_rds_base_module_store_resource_fn_t\fP )(\fBopal_list_t\fP *)"
.br
.RI "\fIAdd a list of resources to the Resource Segment. \fP"
.ti -1c
.RI "typedef orte_rds_base_module_1_0_0_t \fBorte_rds_base_module_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef orte_rds_base_module_1_0_0_t \fBorte_rds_base_module_t\fP"
.br
.ti -1c
.RI "typedef orte_rds_base_module_t *(* \fBorte_rds_base_component_init_fn_t\fP )(void)"
.br
.ti -1c
.RI "typedef orte_rds_base_component_1_0_0_t \fBorte_rds_base_component_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef orte_rds_base_component_1_0_0_t \fBorte_rds_base_component_t\fP"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC orte_rds_base_module_t \fBorte_rds\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
The Open RTE Resource Discovery Subsystem (RDS). 

The resource discovery subsystem is responsible for discovering information about computing resources available to the ORTE universe. The information provided is stored on the registry for use by other subsystems, and is assumed to represent some base state - in other words, the resource discovery information provides a picture of what COULD be available, and not what necessarily IS available at a specific point in time.
.PP
This can best be understood by considering two examples:
.PP
1. A resource file (e.g., etc/lanl_resources.xml) describes one or more computing resources in a given site. Information included in the file tells the ORTE system how many compute nodes are available on a given cluster, the type of interconnect used, the resource management software used, etc. This info subsequently is used by the system to assist ORTE in determining how best to interact with the cluster to provide the best performance for a user's application. Resource files are intended to be provided at the site (as opposed to user) level, though users can define their own resource files if desired (e.g., to describe resources they have access to at some foreign site).
.PP
2. A hostfile (e.g., etc/openmpi-default-hostfile) describes a set of hosts to which a specific user has access and may wish to use to run applications. The information in the hostfile is much less detailed than in a resource file - it is primarily intended to allow a user to specify which hosts are available for use in an unmanaged environment (e.g, one spawned by rsh/ssh as opposed to a BProc system), and potentially how the application's processes can/are to be distributed across them. Thus, one would not expect to find info on memory/node in a hostfile, but would expect to find info on user id for a given host and the maximum number of processes the user wants put on a given host.
.PP
The location and name of the input files to be read (or whatever input information source the component utilizes) will be provided via the MCA parameter mechanism. Users will provide the information either via environmental parameters or as options on the command line. Thus, the RDS components must be aware that another application invocation may have already populated the registry with information on a given resource. In addition, each component must be capable of accepting and processing info from multiple input sources (e.g., a user may specify several resource files, one from the site and one or more that the user has pesonally created to describe foreign sites).
.PP
NOTE: It is the responsibility of each component to define unique MCA parameters for passing their required input information.
.PP
The information developed by the RDS is placed on the ORTE_RESOURCE_SEGMENT of the registry. To ensure proper operation, the information MUST be described by the following tokens:
.PP
.IP "\(bu" 2
site name: the name of the site wherein the resource resides (e.g., 'lanl')
.PP
.PP
.IP "\(bu" 2
resource name: the name of the specific resource being described (e.g., 'pink')
.PP
.PP
.IP "\(bu" 2
cellid: a unique id for this resource (termed a 'cell') that is generated by the ORTE name services (NS) subsystem.
.PP
.PP
Keywords to describe the individual data elements within the resource are mostly defined in the \fBrds_types.h\fP file. However, some higher level types (e.g., nodename) may be defined in the include/orte_names.h file as they need to be generally understandable across multiple subsystems.
.PP
The resource allocation subsystem (RAS) is the primary consumer of this information, although other subsystems can also access it. The information is typically read at the start of any application, but can also be accessed dynamically when an application requests additional resources as part of a spawn process. The RAS does NOT alter the information placed by the RDS on the ORTE_RESOURCE_SEGMENT, but augments it with a dynamic count of the resources currently allocated/consumed from each resource defined on the segment. Thus, the ORTE_RESOURCE_SEGMENT, contains both static and dynamic information. This allows the allocator, for example, to possibly determine that a request for additional resources should draw from another compute resource as the requested one is already fully consumed.
.PP
Consumers of the information must always be prepared to find 'holes' or 'gaps' in the information itself. The RDS can ONLY provide information it is given - it has no dynamic discovery capabilities of its own at this time. Hence, if a resource file doesn't provide any info on the launcher used by a particular cluster, then other subsystems must be prepared to operate without it - or at least detect that this information is not available and act accordintly.
.PP
Because the RDS operates as a multi-component subsystem (i.e., multiple components are instantiated at any one time), its functions should NOT be accessed directly. Instead, all calls to RDS functions should be made through the ORTE Resource Manager (RMGR) subsystem to ensure proper operation.
.SH "Define Documentation"
.PP 
.SS "#define ORTE_RDS_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* rds v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* rds v1.0 */ \
  'rds', 1, 0, 0
.fi
.SH "Typedef Documentation"
.PP 
.SS "typedef int(* \fBorte_rds_base_module_query_fn_t\fP)(void)"
.PP
Query/update a resource The query function requests that the component read its associated information and store/update it on the ORTE_RESOURCE_SEGMENT of the registry. 
.PP
It must be emphasized that this function has to support multiple calls in case the user updates an input file or data source while the ORTE system is in operation - the function should not assume that the registry is currently empty. The registry design accommodates this need by providing an 'overwrite' capability that allows the user to permit updating of existing info if it exists, while still adding the info to the registry if prior info does not exist.
.PP
Requests to update the resource information will be manually provided. The RDS is NOT responsible for detecting changes in input information and automatically updating itself.
.PP
.PP
.nf
 return_value = orte_rmgr.query();
.fi
.PP
 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
